module operateur


contains
!===============================================================================
  subroutine laplacien ( A,dx,dy,Nx,Ny)
!===============================================================================


implicit none


real (kind=8), dimension(:,:), allocatable, intent(out) :: A
        real (kind=8), intent(in) :: dx,dy
        integer, intent(in) :: Nx,Ny


        integer :: i,j,l
        allocate(A(Nx*Ny,Nx*Ny))
        A=0.d0
        do i=1, Nx*Ny
           A(i,i)=2/dx**2+2/dy**2
        end do
        l=0
        do j=1,Ny
           do i=1,Nx
              l=l+1
              if (i<Nx) A(l,l+1)=-1/dx**2
              if (i>1) A(l,l-1)=-1/dx**2
              if (j<Ny) A(l,l+Nx)=-1/dy**2
              if (j>1) A(l,l-Nx)=-1/dy**2
           end do
        end do
 
  end subroutine laplacien
!=====================================================================================

!===============================================================================
  subroutine laplacien1D ( A,dx,Nx )
!===============================================================================


implicit none


real (kind=8), dimension(:,:), allocatable, intent(out) :: A
        real (kind=8), intent(in) :: dx
        integer, intent(in) :: Nx


        integer :: i,l
        allocate(A(Nx,Nx))
        A=0.d0
        do i=1, Nx
           A(i,i)=2/dx**2
        end do
        l=0
        do i=1,Nx
           l=l+1
           if (i<Nx) A(l,l+1)=-1/dx**2
           if (i>1) A(l,l-1)=-1/dx**2
        end do
         
      end subroutine laplacien1D
!============================




end module operateur
